<script lang="ts">
	import type { Value } from "./Value";
	import { ValueType, ToType, GetValue } from "./Value";
	import { GetVal } from "./utils";
	import TypeSelector from "./TypeSelector.svelte";

	import { createEventDispatcher } from "svelte";
	const dispatch = createEventDispatcher();

	export let value: Value;

	let type: ValueType;
	let val: number;
	$: type = ToType(value);
	$: val = GetValue(value);

	function update(t: ValueType, v: number) {
		if (t != ValueType.Float) {
			v = Math.round(v);
		}
		console.log("TV", t, v);
		dispatch("value", { [t]: v });
	}
</script>

<div>
	<div class="lbl">
		<slot />
	</div>
	<TypeSelector value={type} on:input={(e) => update(e.detail, val)} />
	<input
		type="number"
		class={type}
		bind:value={val}
		on:input={(e) => update(type, +GetVal(e))}
	/>
</div>

<style lang="sass">
	div
		display: flex
		align-items: baseline
		.lbl
			flex: 1

	input
		color: white
		background-color: orangered
		&.U16
			background-color: green
		&.I16
			background-color: blue
		&.I32
			background-color: red
		&.Float
			background-color: purple
</style>
